{
Info:
Grid with a TreeColumn
"neue version"

Hinweise:
1. 0 fr nicht NodeId benutzt 1.node beginnt mit 1, wenn man hauptknoten hinzufgen will dann soll
   man 0 bergeben.
IDEEN:
1. Zwischen Rootnodes eine Zeile optionale Platz freilassen

TODO:
1. Manuelle Expansion fertig es fehlt AWertung von Mausklicks

}

{$DEFINE  DEVDEBUG}
unit sGridTree;

{$MODE Delphi}

interface

uses
  SysUtils, Classes, Controls, Graphics, KControls, KGrids, Types;

type
  TNodeTyp = (ntItem, ntTitle, ntSpace); //ncItem : normale spalte, ncTitle: Titel fr Abschnitt alle Spalten werden als eins Dargestellt, ncSpace = Leerzeile

  TNodeResult = record
    NodeId : Cardinal;                    //=0 wenn keine Knoten hinzugefgt wurde (Weil parent knoten nicht gefunden ist ...)
    Row    : Integer;                     //Row nicht dauerhaft verwenden weil das nach  hinzufgen weitere Knoten gendert wird. Es ist nur sofort benutzung nach hinzufgen gedacht!
  end;

  TSGridTree = class(TKGrid)
  private
    fNodeIdCounter : Cardinal;               // Fngt bei jedesmal von 0 an und wird nach dem einfgen eines Knotens immer inkrementiert
    fNodeCol       : Integer;                // Welche Spalte als Treeknoten benutzt wird
    fLevIndent : Integer;                    // wieviele pixel jede Level eingerckt wird vor dem plus
    fNodesSorted : Boolean;                  // ob beim einfgen Sortiert werden soll
    fImgPlus   : TBitmap;
    fImgMinus  : TBitmap;
  protected
    fValid : Boolean;                        //gibt an ob inhalt gltig ist.Notwendig weil ein Grid mindenstens eine Zeile haben mu
       // Erstellt NodeID
    function CreateNodeId: Cardinal;
       // Liefert eine Position um einzufgen
    function GetAddRowSorted(ANodeId: Cardinal; out ONodeLevel:Integer; out OExpanded: Boolean; AAsChild:Boolean): Integer;
    function GetAddRow(ANodeId: Cardinal; out ONodeLevel:Integer; out OExpanded: Boolean; AAsChild:Boolean): Integer;

    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    //procedure MouseCeDblClickCell(ACol, ARow: Integer); override;
    function DrawCell(ACol, ARow: Integer; ARect: TRect; AState: TKGridDrawState): Boolean; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
       // Lscht alle Zeilen
    procedure Clear;
        // Liefert -1 wenn es nicht gefunden ist
    function NodeGetRow(ANodeId: Cardinal): Integer;
        // Liefert 0 wenn es nicht gefunden ist
    function NodeGetId(ARow: integer): Cardinal;
       // Die Methode NodeExpand erweitert(AExpand=true) oder schliet (AExpand=false) den Knoten mit ANodeID.
    procedure NodeExpand(ANodeId: Cardinal; AExpand: Boolean);
       // Die Methode FullExpand erweitert(AExpand=true) oder schliet (AExpand=false) alle Knoten.
    //procedure FullExpand(AExpand: Boolean);
	            {Die Methode AddNode fgt einem Baumdiagramm-Steuerelement einen neuen Knoten hinzu (am Ende des Levels wenn NodesSorted=false ist).
					 Wenn ANodeID=0 ist dann wird eine neue Root-Knoten hinzugefgt, bei fNodesSorted=false wird an richtigen Stelle hinzugefgt.
					 Wenn ANodeID<>0 ist dann wird eine neue Knoten auf der gleichen Level wie der mit dem ID hinzugefgt, bei fNodesSorted=false wird an richtigen Stelle hinzugefgt.
           AAsChild=true : Knoten wird als Kind hinzugefgt}
  	function NodeAdd(ANodeId: Cardinal; const AText: string; AAsChild:Boolean=false; ATyp: TNodeTyp=ntItem): TNodeResult;
           { DeleteNode lscht Knoten (ANodeId>0) und alle Seine Kinder}
    procedure NodeDelete(ANodeId: Cardinal);
    function NodeHasChildren(ANodeId: Cardinal):Boolean;
  published
    { Published declarations }
  end;

procedure Register;

implementation

uses KGraphics;

{$R sgridtreeimgs.res}

{$IFDEF  DEVDEBUG}
var testddZeileNr: Integer=1;
{$ENDIF}

procedure Register;
begin
  RegisterComponents('Ext', [TSGridTree]);
end;

// TNodeCell ================================================= TNodeCell =======

type
  // TNodeCell ist hier weil es nicht auerahlb benutzbar ist, man soll mit NodeId arbeiten.
  TNodeCell = class(TKGridTextCell)
  protected
    fNodeId    : Cardinal;
    fLevel     : Integer;
    fExpanded  : Boolean;
    fNodeTyp   : TNodeTyp;
    procedure Initialize; override;
  public
    procedure Assign(Source: TKGridCell); override;
    property NodeId  : Cardinal read fNodeId;
    property Level   : Integer  read fLevel write fLevel;
    property Expanded: Boolean  read fExpanded write fExpanded;
    property NodeTyp : TNodeTyp read fNodeTyp write fNodeTyp;
    //You can add maybe ImageIndex or Tag attributes
  end;

procedure TNodeCell.Initialize;
begin
  Inherited Initialize;
  fNodeId:= 0; //das ist dummywert es wird zugewiesen von tree
  fExpanded:=false;
  fLevel:=0;
  fNodeTyp:=ntItem;
end;

procedure TNodeCell.Assign(Source: TKGridCell);
begin
  inherited Assign(Source);

  if Source is TNodeCell then begin
    fNodeId :=TNodeCell(Source).NodeId;
    Expanded:=TNodeCell(Source).Expanded;
    Level:=TNodeCell(Source).Level;
    NodeTyp:=TNodeCell(Source).NodeTyp;
  end;
end;

// TSGridTree ================================================= TSGridTree =======

constructor TSGridTree.Create(AOwner: TComponent);
begin
  inherited;
  //wichtige Variablen
  fNodeIdCounter:=0;                // keine Node bekommt 0, null ist definition bei paramatern als level 0 node
  fNodeCol      :=0;                // Welche Spalte als Treeknoten benutzt wird
  fLevIndent    :=0;
  fNodesSorted  :=false;                  // ob beim einfgen Sortiert werden soll
  fValid := false;                        //gibt an ob inhalt gltig ist.Notwendig weil ein Grid mindenstens eine Zeile haben mu

  //bilder
  fImgPlus   :=TBitmap.Create;
   fImgPlus.LoadFromResourceName(HInstance,'TSGRIDTREEIMGPLUS');
   fImgPlus.Transparent:=True; 
  fImgMinus:=TBitmap.Create;
   fImgMinus.LoadFromResourceName(HInstance,'TSGRIDTREEIMGMINUS');
   fImgMinus.Transparent:=True;

  //von KGrid
  CellClass := TNodeCell; // register custom cell class
  FixedCols:=0;
  ColCount:=1;
  RowCount:=FixedRows+1;  //es mu min FixedRows+1 sein
  DefaultRowHeight:=17;
  Options:=Options+[goColSizing]-[goIndicateHiddenCells];
  ColWidths[fNodeCol]:=120;
  MinRowHeight:=0; //damit man es nicht visible machen kann
  {$IFDEF  DEVDEBUG}
   ColCount:=2
  {$ENDIF}
  //
end;

destructor TSGridTree.Destroy;
begin
  if Assigned(fImgPlus) then fImgPlus.Free;
  if Assigned(fImgMinus) then fImgMinus.Free;

  inherited;
end;


procedure TSGridTree.Clear;
var i : Integer;
begin
   fValid := False;
   RowCount:=FixedRows+1;
   for i:=FixedCols to ColCount-1 do
     Cells[i,FixedRows]:='';
end;

function TSGridTree.CreateNodeId: Cardinal;
begin
  Inc(fNodeIdCounter);
  Result:=fNodeIdCounter;
end;

function TSGridTree.NodeGetRow(ANodeId: Cardinal): Integer;
var r: Integer;
begin
  Result:=-1;
  if not fValid then Exit;

  for r:=FixedRows to RowCount-1 do
    if TNodeCell(Cell[fNodeCol,r]).NodeId=ANodeId then begin
      Result:=r;
      Break;
    end;
end;

function TSGridTree.NodeGetId(ARow: integer): Cardinal;
begin
  Result:=0;
  if (not fValid) or (ARow<0) or (ARow>=RowCount) then Exit;

  Result:=TNodeCell(Cell[fNodeCol,ARow]).NodeId;
end;

function TSGridTree.GetAddRow(ANodeId: Cardinal; out ONodeLevel:Integer; out OExpanded: Boolean; AAsChild:Boolean): Integer;
var r, vlev: Integer;
begin
  Result:=-1;
  if not fValid then Exit;

  for r:=FixedRows to RowCount-1 do
    if TNodeCell(Cell[fNodeCol,r]).NodeId=ANodeId then begin
      Result:=r;
      Break;
    end;


  if (Result>-1) then begin
    ONodeLevel:=TNodeCell(Cell[fNodeCol,Result]).Level;
    OExpanded:=TNodeCell(Cell[fNodeCol,Result]).Expanded;
    Result:=Result+1;

    if (Result<RowCount) then begin //jetzt kinder und gleiche Level berspringen
      if AAsChild then vlev:=ONodeLevel+1
      else vlev:=ONodeLevel;
      for r:=Result to RowCount-1 do
        if TNodeCell(Cell[fNodeCol,r]).Level<vlev then Break;
      Result:=r;
    end;
  end;

end;

function TSGridTree.GetAddRowSorted(ANodeId: Cardinal; out ONodeLevel:Integer; out OExpanded: Boolean; AAsChild:Boolean): Integer;
begin
  {TODO -cErweiterung: Sorted-Code Fehlt}
  //Falls Result zwischen anderen Zeilen ist dann fge eine Zeile mit InsertRow
  Result:=-1;
end;

function TSGridTree.NodeAdd(ANodeId: Cardinal; const AText: string; AAsChild:Boolean=false; ATyp: TNodeTyp=ntItem): TNodeResult;
var r: Integer;
 procedure aAddNode(ALevel: Integer);
 begin
   TNodeCell(Cell[fNodeCol,r]).Text:=AText; //Cells[fNodeCol,r]:=AText;
   TNodeCell(Cell[fNodeCol,r]).fNodeId:=   CreateNodeId;
   TNodeCell(Cell[fNodeCol,r]).fLevel:=    ALevel;
   TNodeCell(Cell[fNodeCol,r]).fExpanded:= true;
   TNodeCell(Cell[fNodeCol,r]).fNodeTyp:=  ATyp;
 end;

var aNodeLevel:Integer;
    vExpanded: Boolean;
begin
  {TODO -cErweiterung: Sorted-Code deaktiviert}
  if ANodeId=0 then begin //hauptknoten hinzufgen
    aNodeLevel:=0;
    {if fNodesSorted then r:=GetAddRowSorted(ANodeId)
    else} begin
       if fValid then begin
        r:=RowCount;
        RowCount:=RowCount+1;
       end
       else r:=RowCount-1; //weil diese Zeile leer ist

       aAddNode(aNodeLevel);
       Result.NodeId:=TNodeCell(Cell[fNodeCol,r]).fNodeId;
       Result.Row:=r;
    end;

  end
  else begin
    {if fNodesSorted then r:=GetAddRowSorted(ANodeId)
    else} r:=GetAddRow(ANodeId, aNodeLevel, vExpanded, AAsChild);
    if r<0 then begin
      Result.NodeId:=0;
      Result.Row:=-1;
    end
    else begin
      InsertRow(r);
      if AAsChild then begin
        aAddNode(aNodeLevel+1);
        if vExpanded=false then Rows[r].Visible:=false; //!!! wenn man bei visible-row Rows[r].Visible:=vExpanded macht wird zeile mit mini-gre angezigt 
      end
      else aAddNode(aNodeLevel);
      Result.NodeId:=TNodeCell(Cell[fNodeCol,r]).fNodeId;
      Result.Row:=r;
    end;

  end;

  if (Result.NodeId>0) and (not fValid) then fValid:=True; //grid jetzt gltig
end;

procedure TSGridTree.NodeDelete(ANodeId: Cardinal);
var r, l: Integer;
begin
   r:=NodeGetRow(ANodeId);
   if r<0 then Exit;
   l:=TNodeCell(Cell[fNodeCol,r]).Level;

   if RowCount>(FixedRows+1) then DeleteRow(r)
   else Clear;
   //alle kinder lschen
   while (r<RowCount) and (TNodeCell(Cell[fNodeCol,r]).Level>l) do
     if (r<(RowCount-FixedRows)) then DeleteRow(r)
     else begin
       Clear;
       Break;
     end;

  {TODO -cErweiterung: Vielleicht OnNodeDelete implementieren}
end;

procedure TSGridTree.NodeExpand(ANodeId: Cardinal; AExpand: Boolean);
   function ExpandSub(BreakLevel, SearchLevel, FromRow: Integer; ParExp: Boolean):Integer; //wenn ParExp=false ist dann alle abhngigen kinder nicht sichtbar sonst untersuchen
   var r: integer;
   begin
     r:=FromRow;
     while r<RowCount do begin
       if (TNodeCell(Cell[fNodeCol,r]).Level<=BreakLevel)or (TNodeCell(Cell[fNodeCol,r]).Level<SearchLevel) then Break
       else if TNodeCell(Cell[fNodeCol,r]).Level>SearchLevel then begin
         r:=ExpandSub(BreakLevel, TNodeCell(Cell[fNodeCol,r]).Level, r,  ParExp and TNodeCell(Cell[fNodeCol,r-1]).Expanded);
         if r>=RowCount then Break; //nach der mglichen Rekursion noch mal grenze prfen
       end;

       if (ParExp=False) then Rows[r].Visible:=false
       else if not Rows[r].Visible then Rows[r].Visible:=ParExp;

       Inc(r);
     end;
     Result:=r;
   end;
var r, vlev, parlev: Integer;
    parexpanded: Boolean;
{    ARect: TRect;
    aChangedRow: Integer;
    AState: TKGridDrawState;}
begin
   r:=NodeGetRow(ANodeId);
   if r<1 then Exit;
   if TNodeCell(Cell[fNodeCol,r]).Expanded=AExpand then Exit;

   //aChangedRow:=r;

   TNodeCell(Cell[fNodeCol,r]).Expanded:=AExpand;
   vlev:=TNodeCell(Cell[fNodeCol,r]).Level;

   parlev:=TNodeCell(Cell[fNodeCol,r]).Level;
   parexpanded:=TNodeCell(Cell[fNodeCol,r]).Expanded;

   Inc(r);
   if (r<RowCount) then begin //jetzt kinder auschalten
     if AExpand=False then
       while r<RowCount do begin
        if TNodeCell(Cell[fNodeCol,r]).Level<=vlev then Break
        else  Rows[r].Visible:=AExpand;

        Inc(r);
       end
     else begin //beim einblenden recusion verwenden
       ExpandSub(parlev, TNodeCell(Cell[fNodeCol,r]).Level, r, parexpanded);
     end;

   end;

   {TODO  : Nach Expanded=false die Zelle mit Pfeil neue zeichnen, funktion zeichnet an der falschen stelle, irgendwie ist kgrid buggy}
   {if AExpand=false then  begin
      CellRect(fNodeCol, AChangedRow, ARect);
      if (Col=fNodeCol)and(Row=aChangedRow) then begin
        if Focused then AState:=[gdSelected, gdFocused]
        else AState:=[gdSelected];
      end
      else AState:=[];
      //obwohl alle Koordinaten richtig berechnet und bergeben werden, es zeichnet an der falschen stelle
      self.DrawCell(fNodeCol, AChangedRow, ARect, AState); //bei state brauchtman nur gdSelected und  gdfocused(bedingung gdSelected and focused) zu untersuchen
   end;}
end;

function TSGridTree.NodeHasChildren(ANodeId: Cardinal):Boolean;
var r:Integer;
begin
  Result:=False;

  r:=NodeGetRow(ANodeId);
  if r<1 then Exit;

  if r<(RowCount-1) then Result:=TNodeCell(Cell[fNodeCol,r]).Level<TNodeCell(Cell[fNodeCol,r+1]).Level
  else Result:=False;
end;

procedure TSGridTree.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var c,r, aImgWid, l: Integer;
    aHasChildren: Boolean;
begin
  inherited;
  if Button<>mbLeft then exit;
  MouseToCell(X,Y, c,r);
  if (c<>fNodeCol) or (r<FixedRows) or (r>=RowCount) then Exit;

  {TODO : Koordinaten mssen spter besser eingestellt werden.}
  //koodinaten
  if Assigned(fImgPlus) then aImgWid:=fImgPlus.Width
  else aImgWid:=14;
  if aImgWid=0 then  aImgWid:=14;
  l:=(TNodeCell(Cell[fNodeCol,r]).Level*aImgWid);
  //koordinaten end

  if (x>l)and(x<(l+aImgWid)) then begin
      if r<(RowCount-1) then aHasChildren:=TNodeCell(Cell[fNodeCol,r]).Level<TNodeCell(Cell[fNodeCol,r+1]).Level
      else aHasChildren:=False;
      if aHasChildren then NodeExpand(TNodeCell(Cell[fNodeCol,r]).fNodeId,not TNodeCell(Cell[fNodeCol,r]).fExpanded);
  end;
end;

function TSGridTree.DrawCell(ACol, ARow: Integer; ARect: TRect; AState: TKGridDrawState): Boolean;
var aHasChildren: Boolean;
    aImgWid, aLevel: Integer;
begin
  if (ARow>=FixedRows) then begin
    if (ACol=fNodeCol) then begin
      CellPainter.Text:=Cells[ACol,ARow];

     CellPainter.GraphicHAlign := halLeft;
     CellPainter.GraphicVAlign := valCenter;
          CellPainter.GraphicDrawText := True;
      if Assigned(fImgPlus) then aImgWid:=fImgPlus.Width
      else aImgWid:=14;
      if aImgWid=0 then  aImgWid:=14;
      aLevel:=TNodeCell(Cell[fNodeCol,ARow]).Level;
      if ARow<(RowCount-1) then aHasChildren:=TNodeCell(Cell[fNodeCol,ARow]).Level<TNodeCell(Cell[fNodeCol,ARow+1]).Level
      else aHasChildren:=False;
      if aHasChildren then begin
        if TNodeCell(Cell[fNodeCol,ARow]).Expanded then CellPainter.Graphic := fImgMinus
        else CellPainter.Graphic := fImgPlus;
        CellPainter.GraphicHPadding :=(aLevel*aImgWid)+fLevIndent;
        CellPainter.HPadding:=0;
      end
      else CellPainter.HPadding:=((aLevel+1)*aImgWid)+fLevIndent; //((fImgPlus.Width+2)*(aLevel+1))+ TNodeCell(Cell[fNodeCol,ARow]).Level; //CellPainter.HPadding:=aXIndent+ TNodeCell(Cell[fNodeCol,ARow]).Level*fLevIndent;
    end

    {$IFDEF  DEVDEBUG}
    else if ACol=testddZeileNr then CellPainter.Text:='Id:'+IntToStr(TNodeCell(Cell[fNodeCol,ARow]).NodeId)+' L:'+IntToStr(TNodeCell(Cell[fNodeCol,ARow]).Level)+' Z: '+ IntToStr(ARow)
    {$ENDIF}
    else  CellPainter.Text:=Cells[ACol,ARow];

    CellPainter.Attributes:=CellPainter.Attributes-[taEndEllipsis];
    
    CellPainter.DefaultDraw;
    Result:=true;
  end
  //standard routine
  else Result:=inherited DrawCell(ACol, ARow, ARect, AState);
end;

end.
